package fmon.stat

import scala.io.Source

import fmon.util.YamlHelper

case class Element(val name : String, val effect : Map[String, Double]) {
  
  def -->(other : Element) = {
    effect.getOrElse(other.name, 1.0)
  }
  
  def <--(other : Element) = other --> this
  
  override def toString = name
}

object Element {
  private val elements = YamlHelper.extractMap[Element](Element.getClass.getResourceAsStream("data/elements.yaml"))
  
  def apply(name : String) = elements(name)
}